package fr.eni.ep3jasp;

import fr.eni.ep3jasp.services.ResourceLoaderAndPrinter;

import lombok.extern.slf4j.Slf4j;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.FileSystemResource;
import org.springframework.core.io.Resource;
import org.springframework.core.io.UrlResource;
import org.springframework.stereotype.Service;

import java.io.IOException;


/**
 * Les fichiers de ressources standards
 *
 * @author $author$
 * @version $Revision$
  */
@Slf4j
public class Ressources1 {

  /**
   * Point d'entrée
   *
   * @param args Arguments de la ligne de commande
   *
   * @throws IOException Exception levée
   */
  public static void main(String[] args) throws IOException {
    ApplicationContext ctx = new ClassPathXmlApplicationContext(new String[] {
        "applicationContext.xml"
    });

    ResourceLoaderAndPrinter resourceLoaderAndPrinter=
        (ResourceLoaderAndPrinter)ctx.getBean("loaderprinter");

    String fichier = System.getProperty("user.dir") +
            "/chap05/chap05.avance/src/main/resources/fr/eni/ep3jasp/ressource.txt";
    log.info("Fichier:" + fichier);

    Resource r0 = new FileSystemResource(fichier);
    resourceLoaderAndPrinter.traiterRessource(r0,"FileSystemResource");

    Resource r1 = new UrlResource("file:" + fichier);
    resourceLoaderAndPrinter.traiterRessource(r1,"UrlResource");

    Resource r2 = new ClassPathResource("fr/eni/ep3jasp/ressource.txt");
    resourceLoaderAndPrinter.traiterRessource(r2,"ClassPathResource");
  }
}
