package fr.eni.ep3jasp;

import lombok.extern.slf4j.Slf4j;

import org.springframework.core.convert.support.GenericConversionService;


/**
 * Conversion en utilisant des factories 
 * UtilisateurToStringConverterFactory et StringToUtilisateurConverterFactory
 *
 * @author $author$
 * @version $Revision$
  */
@Slf4j
public class Conversions6 {
  /**
   * Point d'entrée
   *
   * @param args Arguments de la ligne de commande
   */	
	public static void main(String[] args) {
    GenericConversionService conversionService = new GenericConversionService();

    conversionService.addConverterFactory(new UtilisateurToStringConverterFactory());
    conversionService.addConverterFactory(new StringToUtilisateurConverterFactory());

    String utilisateurAsString = "5,Janelle,VOIGHT";
    Utilisateur utilisateur = conversionService.convert(utilisateurAsString,
        Utilisateur.class);
    System.out.println("Le nom est " + utilisateur.getNom());
    System.out.println("Le prénom est " + utilisateur.getPrenom());

    utilisateurAsString = conversionService.convert(utilisateur, String.class);
    System.out.println("Utilisateur en chaine : [" + utilisateurAsString + "]");
  }
}
