package fr.eni.ep3jasp.apis;

import org.springframework.aop.ClassFilter;
import org.springframework.aop.MethodMatcher;
import org.springframework.aop.Pointcut;

import java.lang.reflect.Method;


/**
 * Exemples d'utilisation des API de l'AOP Spring
 *
 * @author $author$
 * @version $Revision$
  */
class MonPointcut implements Pointcut {
  /**
   * Le getter filtre de classe
   *
   * @return Le filtre de classe
   */
  public ClassFilter getClassFilter() {
    return null;
  }

  /**
   * Le getter de la méthode de comparaison
   *
   * @return La méthode de comparaison
   */
  public MethodMatcher getMethodMatcher() {
    return null;
  }
}


/**
 * Le filtre de classe personnalisé
 *
 * @author $author$
 * @version $Revision$
  */
class MonClassFilter implements ClassFilter {
  /**
   * Méthode de comparaison
   *
   * @param clazz La classe
   *
   * @return Le résultat de la comparaison
   */
  public boolean matches(Class<?> clazz) {
    return false;
  }
}


/**
 * Comparateur de méthode personnalisé
 *
 * @author $author$
 * @version $Revision$
  */
class MonMethodMatcher implements MethodMatcher {
  /**
   * La méthode de comparaison
   *
   * @param method La méthode
   * @param targetClass La classe cible
   *
   * @return Le résultat de la comparaison
   */
  public boolean matches(Method method, Class<?> targetClass) {
    return false;
  }

  /**
   * Getter flag runtime
   *
   * @return Le flag runtime
   */
  public boolean isRuntime() {
    return false;
  }

  /**
   * Méthode de comparaison
   *
   * @param method La méthode
   * @param targetClass La classe cible
   * @param args Les arguments
   *
   * @return Le résultat de la comparaison
   */
  public boolean matches(Method method, Class<?> targetClass, Object[] args) {
    return false;
  }
}



