package fr.eni.ep3jasp.pointcut;

import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;

import java.util.Arrays;
import java.util.Collection;

/**
 * DOCUMENT ME!
 *
 * @author $author$
 * @version $Revision$
  *
 * @param <T> DOCUMENT ME!
 */
interface Sample<T> {
  /**
   * DOCUMENT ME!
   *
   * @param param DOCUMENT ME!
   */
  void sampleGenericMethod(T param);

  /**
   * DOCUMENT ME!
   *
   * @param param DOCUMENT ME!
   */
  void sampleGenericCollectionMethod(Collection<T> param);
}


/**
 * DOCUMENT ME!
 *
 * @author $author$
 * @version $Revision$
  */
@Component
@Aspect
public class VerifierAvant {
  /**
   * DOCUMENT ME!
   */
  private static final Logger logger = LoggerFactory.getLogger(VerifierAvant.class);

  /**
   * DOCUMENT ME!
   *
   * @param param DOCUMENT ME!
   */
  @Before("execution(* ..Sample+.sampleGenericMethod(*)) && args(param)")
  public void beforeSampleMethod(MyType param) {
    // Advice implementation
  }

  /**
   * DOCUMENT ME!
   *
   * @param param DOCUMENT ME!
   */
  @Before("execution(* ..Sample+.sampleGenericCollectionMethod(*)) && args(param)")
  public void beforeSampleMethod(Collection<MyType> param) {
    // Advice implementation
  }

  /**
   * DOCUMENT ME!
   *
   * @param param DOCUMENT ME!
   */
  @Before("execution(* ..Sample+.sampleGenericCollectionMethod(*)) && args(param)")
  public void beforeSampleMethod2(Collection<?> param) {
    // Advice implementation
  }

  /**
   * DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   */
  public int getOrder() {
    // TODO Auto-generated method stub
    return 0;
  }

  /*
          UsageTracked usageTracked = (UsageTracked) context.getBean("myService");
  */
  /**
   * DOCUMENT ME!
   */
  @Pointcut("execution(* voir*(..))")
  public void aspectjLoadTimeWeavingExamples() {
  }

  /**
   * DOCUMENT ME!
   */
  @Pointcut("execution(* entendre*(..))")
  public void aspectjLoadTimeWeavingExamples2() {
  }

  /**
   * DOCUMENT ME!
   *
   * @param pjp DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   *
   * @throws Throwable L'exception à transmettre
   */
  @Around("aspectjLoadTimeWeavingExamples()")
  public Object profile(ProceedingJoinPoint pjp) throws Throwable {
    final Logger logger = LoggerFactory.getLogger(pjp.getSignature()
                                                     .getDeclaringType());

    logger.info("logAround() is running!");
    logger.info("hijacked method : " + pjp.getSignature().getName());
    logger.info("hijacked arguments : " + Arrays.toString(pjp.getArgs()));

    logger.info("Around before is running!");

    Object ret = pjp.proceed();
    logger.info("Around after is running!");

    logger.info("******");

    return ret;
  }

  /**
   * DOCUMENT ME!
   */
  @Before("execution(* fr.eni.beans.Bateau.demarrerTurbine(..))")
  public void verifierEssenceTurbine() {
    final Logger logger = LoggerFactory.getLogger(VerifierAvant.class);
    logger.info("avant démarer turbine!");
  }

  /**
   * DOCUMENT ME!
   */
  @Before("execution(* demarrer*(..))")
  public void verifierEssence() {
    System.out.println("avant démarer tout court!");
  }

  /**
   * DOCUMENT ME!
   */
  @After("execution(* demarrer*(..))")
  public void verifierVitesse() {
    System.out.println("Aprés démarrage!");
  }

  //Changer exemple !
  /**
   * DOCUMENT ME!
   *
   * @param retVal DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   */
  @After("execution(* demarrer*(..))")
  public Object verifierEssence(Object retVal) {
    System.out.println("après démarer tout court!");

    return (retVal);
  }

  /**
   * DOCUMENT ME!
   *
   * @param joinPoint DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   *
   * @throws Throwable L'exception à transmettre
   */
  @Around("execution(* demarrer*(..))")
  public Object generique(ProceedingJoinPoint joinPoint)
    throws Throwable {
    final Logger logger = LoggerFactory.getLogger(joinPoint.getSignature()
                                                           .getDeclaringType());

    logger.info("Interception demarrer:");
    logger.info("method : " + joinPoint.getSignature().getName());
    logger.info("arguments : " + Arrays.toString(joinPoint.getArgs()));

    logger.info("Around before is running!");

    Object ret = joinPoint.proceed();
    logger.info("Around after is running!");

    logger.info("Return " + ret.toString());

    return ret;
  }

  //Problème	
  @Aspect
  public class UsageTracking {
    //	    @DeclareParents(value="com.xzy.myapp.service.*+", defaultImpl=DefaultUsageTracked.class)
    //	    public static UsageTracked mixin;
    @Before("com.xyz.myapp.SystemArchitecture.businessService() && this(usageTracked)")
    public void recordUsage(UsageTracked usageTracked) {
      usageTracked.incrementUseCount();
    }
  }

  @Aspect
  public class AfterThrowingExample {
    @AfterThrowing("com.xyz.myapp.SystemArchitecture.dataAccessOperation()")
    public void doRecoveryActions() {
      // ...
    }
  }

  @Aspect
  public class AfterThrowingExample2 {
    @AfterThrowing(pointcut = "com.xyz.myapp.SystemArchitecture.dataAccessOperation()", throwing = "ex")
    public void doRecoveryActions(DataAccessException ex) {
      // ...
    }
  }

  @Aspect
  public class AfterFinallyExample {
    @After("com.xyz.myapp.SystemArchitecture.dataAccessOperation()")
    public void doReleaseLock() {
      // ...
    }
  }
}
