package fr.eni.ep3jasp.chap7;

import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mockito.Mock;
import org.mockito.junit.jupiter.MockitoExtension;
import org.springframework.core.env.Environment;

import static org.mockito.Mockito.when;
import static org.mockito.MockitoAnnotations.initMocks;


/**
 * Test unitaire avec des mocks
 *
 * @author $author$
 * @version $Revision$
  */

@ExtendWith(MockitoExtension.class)
public class MockEnvTests {
  /**
   * l'environnement
   */
  @Mock
  Environment env;

  /**
   * le service
   */
  @Mock
  MonService monService;

  /**
   * Initialisation du TU
   */
  @BeforeEach
  public void init() {
    // Initialisation des mocks 
    initMocks(this);

    // Définition du mock
    //Il faut une variable d'environnemnt pour que ça fonctionne.
    when(this.env.getProperty("M4_HOME")).thenReturn("c:\\M4");

    // Initialisation du service
    monService = new MonServiceImpl();

    // S'assurer que leservice utilise l'environnement mocké
    monService.setEnvironment(this.env);
  }

  /**
   * Action sur l'environnement
   */
  @Test
  public void shouldDoSomething() {
    env = monService.getEnvironment();
  }
}
