import fr.eni.ep3jasp.ComplexeDao;
import fr.eni.ep3jasp.Utilisateur;
import lombok.extern.slf4j.Slf4j;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.datasource.embedded.EmbeddedDatabase;
import org.springframework.jdbc.datasource.embedded.EmbeddedDatabaseBuilder;
import org.springframework.jdbc.datasource.embedded.EmbeddedDatabaseType;

import java.util.List;


//@RunWith(SpringJUnit4ClassRunner.class)
/**
 * Tests base de données embarquée
 *
 * @author $author$
 * @version $Revision$
  */
@Slf4j
public class BdEmbarqueeTest {
  /**
   * La base de donnée embarquée
   */
  private EmbeddedDatabase db;

  /**
   * Préparation du test
   */
  @Before
  public void setUp() {
    // creates an HSQL in-memory database populated from default scripts
    // classpath:schema.sql and classpath:data.sql
    db = new EmbeddedDatabaseBuilder().setType(EmbeddedDatabaseType.H2)
                                      .addScript("mon-schema.sql")
                                      .addScript("mes-data.sql").build();
  }

  /**
   * DOCUMENT ME!
   */
  @Test
  public void createConnection_should_haveDataTypeFactory() {
    ComplexeDao dao = new ComplexeDao();
    dao.setDataSource(db);

    JdbcTemplate jdbcTemplate = new JdbcTemplate(db);

    List<Utilisateur> utilisateurs = dao.getAll();
    log.debug(utilisateurs.toString());
  }

  /**
   * DOCUMENT ME!
   */
  @After
  public void tearDown() {
    db.shutdown();
  }
}
