package fr.eni;

import fr.eni.dao.UtilisateurDao;
import fr.eni.model.Utilisateur;
import lombok.extern.java.Log;
import lombok.extern.slf4j.Slf4j;

import org.apache.commons.dbcp.BasicDataSource;
import org.springframework.beans.factory.BeanFactory;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.PreparedStatementCreator;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.jdbc.datasource.SingleConnectionDataSource;
import org.springframework.jdbc.support.GeneratedKeyHolder;
import org.springframework.jdbc.support.KeyHolder;
import org.springframework.jdbc.support.rowset.SqlRowSet;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import java.util.stream.Collectors;


/**
 * Exemple simple Spring Data
 *
 * @author $author$
 * @version $Revision$
  */
@Slf4j
public class SpringDataEx1 {
  /**
   * Point d'entrée
   *
   * @param args Les arguments de la ligne de commande
   *
   * @throws SQLException L'exception sql levée
   */
  public static void main(String[] args) throws SQLException {
    log.debug("SpringDataEx1:");
    ClassPathXmlApplicationContext appContext;
    appContext = new ClassPathXmlApplicationContext("applicationContext.xml");

    BeanFactory factory = (BeanFactory) appContext;

    UtilisateurDao dao = (UtilisateurDao) factory.getBean("utilisateurDao");

    Utilisateur u1 = new Utilisateur(1, "prenom_a", "nom_a");
    dao.save(u1);
    Utilisateur u2 = new Utilisateur(2, "prenom_b", "nom_a");
    dao.save(u2);

    List<Utilisateur> utilisateurs = dao.findByNomLike("nom_a");

    log.debug(utilisateurs.toString());
  }
}
