package fr.eni;

import lombok.extern.java.Log;
import lombok.extern.slf4j.Slf4j;

import org.apache.commons.dbcp.BasicDataSource;
import org.springframework.beans.factory.BeanFactory;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.jdbc.core.JdbcTemplate;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;


/**
 * Utilisation plus complexe de Spring JDBC
 *
 * @author $author$
 * @version $Revision$
  */
@Slf4j
public class Avancee {
  /**
   * DOCUMENT ME!
   */
  public static ClassPathXmlApplicationContext appContext;

  /**
   * DOCUMENT ME!
   */
  public static BeanFactory factory;

  /**
   * DOCUMENT ME!
   */
  public static void init() {
    appContext = new ClassPathXmlApplicationContext("applicationContext.xml");
    factory = (BeanFactory) appContext;

    BasicDataSource dataSource = (BasicDataSource) factory.getBean("dataSource");

    JdbcTemplate jdbcTemplate = new JdbcTemplate(dataSource);
    jdbcTemplate.execute("drop TABLE IF EXISTS utilisateur");
    jdbcTemplate.execute(
      "create table utilisateur (id serial, nom varchar, prenom varchar)");

    for (int i = 0; i < 500; i++) {
      jdbcTemplate.execute("insert into utilisateur (nom, prenom) values ('A" +
        i + "', 'a" + i + "')");
    }
  }

  /**
   * Point d'entrée
   *
   * @param args Les arguments de la ligne de commande
   * 
   * @throws SQLException L'exception sql levée
   */
  public static void main(String[] args) throws SQLException {
    init();

    AvanceeDao dao = (AvanceeDao) factory.getBean("avanceeDao");

    List<Utilisateur> us = new ArrayList<Utilisateur>();

    for (int i = 0; i < 500; i++) {
      us.add(new Utilisateur(i, "prenom" + i, "Nom" + i));
    }

    log.info("classic JDBC...");

    int[][] res = dao.batchMajPar100(us);

    int nblot = res.length;
    log.info("Nb lots:" + nblot);

    us = dao.get5Prem();
    log.info(us.toString());
  }
}
