package fr.eni;

import lombok.extern.java.Log;
import lombok.extern.slf4j.Slf4j;

import org.apache.commons.dbcp.BasicDataSource;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BatchPreparedStatementSetter;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.ParameterizedPreparedStatementSetter;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.jdbc.core.namedparam.SqlParameterSource;
import org.springframework.jdbc.core.namedparam.SqlParameterSourceUtils;
import org.springframework.stereotype.Repository;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;


/**
 * DOCUMENT ME!
 *
 * @author $author$
 * @version $Revision$
  */
@Slf4j
@Repository
public class AvanceeDao {
  //private BasicDataSource dataSource;
  /**
   * DOCUMENT ME!
   */
  private JdbcTemplate jdbcTemplate;

  /**
   * DOCUMENT ME!
   */
  private NamedParameterJdbcTemplate namedParameterJdbcTemplate;

  /**
   * DOCUMENT ME!
   *
   * @param dataSource DOCUMENT ME!
   */
  @Autowired
  public void setDataSource(BasicDataSource dataSource) {
    log.info("par setter setDataSource");
    //this.dataSource = dataSource;
    this.jdbcTemplate = new JdbcTemplate(dataSource);
    this.namedParameterJdbcTemplate = new NamedParameterJdbcTemplate(dataSource);
  }

  /**
   * DOCUMENT ME!
   *
   * @param actors DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   */
  public int[][] batchMajPar100(final Collection<Utilisateur> actors) {
    int[][] updateCounts = jdbcTemplate.batchUpdate("update utilisateur set nom = ?, prenom = ? where id = ?",
        actors, 100,
        new ParameterizedPreparedStatementSetter<Utilisateur>() {
          public void setValues(PreparedStatement ps, Utilisateur argument)
            throws SQLException {
            ps.setString(1, argument.getNom());
            ps.setString(2, argument.getPrenom());
            ps.setLong(3, argument.getId());
          }
        });

    return updateCounts;
  }

  /**
   * DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   */
  public List<Utilisateur> get5Prem() {
    List<Utilisateur> utilisateurs = jdbcTemplate.query("select nom, prenom, id from utilisateur limit 5",
        new RowMapper<Utilisateur>() {
          public Utilisateur mapRow(ResultSet rs, int rowNum)
            throws SQLException {
            Utilisateur utilisateur = new Utilisateur();
            utilisateur.setNom(rs.getString("nom"));
            utilisateur.setPrenom(rs.getString("prenom"));
            utilisateur.setId(rs.getInt("id"));

            return utilisateur;
          }
        });

    return utilisateurs;
  }
}
