package fr.eni;

import org.apache.commons.dbcp.BasicDataSource;
import org.springframework.beans.factory.BeanFactory;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.jdbc.core.JdbcTemplate;


/**
 * Exemple Spring JDBC config XML
 *
 * @author $author$
 * @version $Revision$
  */
public class ConfigXml {
	public static void main(String[] args) {

		ClassPathXmlApplicationContext appContext = new ClassPathXmlApplicationContext("applicationContext.xml");
		// of course, an ApplicationContext is just a BeanFactory
		BeanFactory factory = (BeanFactory) appContext;
		
		BasicDataSource dataSource = (BasicDataSource) factory.getBean("dataSource");

		JdbcTemplate jdbcTemplate = new JdbcTemplate(dataSource);
		jdbcTemplate.execute("drop TABLE IF EXISTS utilisateur");
		jdbcTemplate.execute("create table utilisateur (id int, nom varchar, prenom varchar)");
		jdbcTemplate.execute("insert into utilisateur (id, nom, prenom) values (1, 'A', 'a')");

		jdbcTemplate.execute("delete from utilisateur");
		jdbcTemplate.execute("drop table utilisateur");
	}
}
