package fr.eni;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;

import lombok.extern.java.Log;
import lombok.extern.slf4j.Slf4j;

import org.apache.commons.dbcp.BasicDataSource;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;

@Slf4j
public class JdbcUtilisateurDao {

	public JdbcUtilisateurDao() {
		super();
	}

	public void setDataSource(BasicDataSource dataSource) {
		log.info("par setter setDataSource");
		this.dataSource = dataSource;
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	// Injecté
	public JdbcUtilisateurDao(BasicDataSource dataSource) {
		super();
		log.info("par constructeur JdbcUtilisateurDao");
		this.dataSource = dataSource;
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	private BasicDataSource dataSource;
	private JdbcTemplate jdbcTemplate;

	public List<Utilisateur> getAll() {
		List<Utilisateur> utilisateurs = jdbcTemplate.query(
				"select nom, prenom from utilisateur",
				new RowMapper<Utilisateur>() {
					public Utilisateur mapRow(ResultSet rs, int rowNum)
							throws SQLException {
						Utilisateur utilisateur = new Utilisateur();
						utilisateur.setNom(rs.getString("nom"));
						utilisateur.setPrenom(rs.getString("prenom"));
						return utilisateur;
					}
				});

		return utilisateurs;
	}

}
