package fr.eni;

import java.sql.Types;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.datasource.SingleConnectionDataSource;
import org.springframework.jdbc.support.rowset.SqlRowSet;

/**
 * Exemple Spring JDBC simple
 *
 * @author $author$
 * @version $Revision$
  */
public class Simple {
	public static void main(String[] args) {
		SingleConnectionDataSource dataSource = new SingleConnectionDataSource();
		dataSource.setDriverClassName("org.h2.Driver");
		dataSource.setUrl("jdbc:h2:~/testsimple");
		dataSource.setUsername("sa");
		dataSource.setPassword("");

		JdbcTemplate jdbcTemplate = new JdbcTemplate(dataSource);
		jdbcTemplate.execute("drop TABLE IF EXISTS utilisateur");
		jdbcTemplate.execute("create table utilisateur (id int, nom varchar, prenom varchar)");
		jdbcTemplate.execute("insert into utilisateur (id, nom, prenom) values (1, 'A', 'a')");
		jdbcTemplate.execute("insert into utilisateur (id, nom, prenom) values (2, 'B', 'b')");
		jdbcTemplate.execute("insert into utilisateur (id, nom, prenom) values (3, 'C', 'c')");
		jdbcTemplate.execute("insert into utilisateur (id, nom, prenom) values (4, 'D', 'd')");
		jdbcTemplate.execute("insert into utilisateur (id, nom, prenom) values (5, 'E', 'e')");
		jdbcTemplate.execute("insert into utilisateur (id, nom, prenom) values (6, 'F', 'f')");
		// Requete simple
		int count = jdbcTemplate.queryForObject("select count(*) from utilisateur", Integer.class);

		System.out.println(count);

		// Agregation
		Object[] parametres = new Object[] { "C" };
		count = jdbcTemplate.queryForObject("select count(*) from utilisateur where nom > ?", Integer.class, parametres);
		
		jdbcTemplate.update("DELETE FROM utilisateur WHERE id = ?", new Object[] { "4" });

		count = jdbcTemplate.queryForObject("select count(*) from utilisateur", Integer.class);
		System.out.println(count);

	    jdbcTemplate.batchUpdate(new String[] { 
	    		"update utilisateur set nom = 'AAA' where id = 3",
                "delete from utilisateur where id = 5" });
	    
	    jdbcTemplate.update("update utilisateur set nom=? where id=?",	    		
	            new Object[] { "Z", 1L }, new int[] { Types.VARCHAR, Types.INTEGER });
	    
	    
	    parametres = new Object[] { new Integer(1) };
	    SqlRowSet sqlRowSet = jdbcTemplate.queryForRowSet("select id, nom, prenom from utilisateur where id > ?", parametres);
	    int rowCount = 0;
	    while (sqlRowSet.next()) {
	      System.out.println(sqlRowSet.getString("id") + " - " + sqlRowSet.getString("nom")+ " - " + sqlRowSet.getString("prenom"));
	      rowCount++;
	    }
	    System.out.println(rowCount);

	    
		
		jdbcTemplate.execute("delete from utilisateur");
		jdbcTemplate.execute("drop table utilisateur");

		dataSource.destroy();
	}

}
