package fr.eni;

import lombok.extern.java.Log;
import lombok.extern.slf4j.Slf4j;

import org.apache.commons.dbcp.BasicDataSource;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.jdbc.core.namedparam.MapSqlParameterSource;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.jdbc.core.namedparam.SqlParameterSource;
import org.springframework.stereotype.Repository;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Collections;
import java.util.List;
import java.util.Map;


/**
 * DOCUMENT ME!
 *
 * @author $author$
 * @version $Revision$
  */
@Slf4j
@Repository
public class JdbcUtilisateurDao {
  /**
   * DOCUMENT ME!
   */
  private BasicDataSource dataSource;

  /**
   * DOCUMENT ME!
   */
  private JdbcTemplate jdbcTemplate;

  /**
   * Creates a new JdbcUtilisateurDao object.
   */
  public JdbcUtilisateurDao() {
    super();
  }

  /**
   * Creates a new JdbcUtilisateurDao object.
   *
   * @param dataSource DOCUMENT ME!
   */
  public JdbcUtilisateurDao(BasicDataSource dataSource) {
    super();
    log.info("par constructeur JdbcUtilisateurDao");
    this.dataSource = dataSource;
    this.jdbcTemplate = new JdbcTemplate(dataSource);
  }

  /**
   * DOCUMENT ME!
   *
   * @param dataSource DOCUMENT ME!
   */
  @Autowired
  public void setDataSource(BasicDataSource dataSource) {
    log.info("par setter setDataSource");
    this.dataSource = dataSource;
    this.jdbcTemplate = new JdbcTemplate(dataSource);
  }

  /**
   * DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   */
  public List<Utilisateur> getAll() {
    List<Utilisateur> utilisateurs = jdbcTemplate.query("select nom, prenom from utilisateur",
        new RowMapper<Utilisateur>() {
          public Utilisateur mapRow(ResultSet rs, int rowNum)
            throws SQLException {
            Utilisateur utilisateur = new Utilisateur();
            utilisateur.setNom(rs.getString("nom"));
            utilisateur.setPrenom(rs.getString("prenom"));

            return utilisateur;
          }
        });

    return utilisateurs;
  }
}
