package fr.eni;

import lombok.extern.java.Log;
import lombok.extern.slf4j.Slf4j;

import org.apache.commons.dbcp.BasicDataSource;
import org.springframework.beans.factory.BeanFactory;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.jdbc.core.JdbcTemplate;

import java.util.List;


/**
 * Exemple Spring JDBC avec style map
 *
 * @author $author$
 * @version $Revision$
  */
@Slf4j
public class StyleMap {
  /**
   * DOCUMENT ME!
   */
  public static ClassPathXmlApplicationContext appContext;

  /**
   * DOCUMENT ME!
   */
  public static void init() {
    BeanFactory factory = (BeanFactory) appContext;
    BasicDataSource dataSource = (BasicDataSource) factory.getBean("dataSource");
    JdbcTemplate jdbcTemplate = new JdbcTemplate(dataSource);
    jdbcTemplate.execute("drop TABLE IF EXISTS utilisateur");
    jdbcTemplate.execute(
      "create table utilisateur (id int, nom varchar, prenom varchar)");
    jdbcTemplate.execute(
      "insert into utilisateur (id, nom, prenom) values (1, 'A', 'a')");
    jdbcTemplate.execute(
      "insert into utilisateur (id, nom, prenom) values (2, 'B', 'b')");
    jdbcTemplate.execute(
      "insert into utilisateur (id, nom, prenom) values (3, 'B', 'c')");
    jdbcTemplate.execute(
      "insert into utilisateur (id, nom, prenom) values (4, 'B', 'd')");
    jdbcTemplate.execute(
      "insert into utilisateur (id, nom, prenom) values (5, 'E', 'e')");
    jdbcTemplate.execute(
      "insert into utilisateur (id, nom, prenom) values (6, 'F', 'f')");
  }

  /**
   * Point d'entrée
   *
   * @param args Les arguments de la ligne de commande
   */
  public static void main(String[] args) {
    appContext = new ClassPathXmlApplicationContext("applicationContext.xml");

    BeanFactory factory = (BeanFactory) appContext;
    init();

    ParameterUtilisateurDao dao = (ParameterUtilisateurDao) factory.getBean(
        "parameterUtilisateurDao");

    int nombreParNom = dao.compterParNom("B");
    log.info("Nombre=" + nombreParNom);

    int nombreParExemple = dao.compterParExemple(new Utilisateur(3, "b", "B"));
    log.info("nombreParExemple=" + nombreParExemple);
  }
}
