package fr.eni;

import lombok.extern.java.Log;
import lombok.extern.slf4j.Slf4j;

import org.apache.commons.dbcp.BasicDataSource;
import org.springframework.beans.factory.BeanFactory;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.jdbc.core.JdbcTemplate;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;


/**
 * Exemple simple Spring JDBC
 *
 * @author $author$
 * @version $Revision$
  */
@Slf4j
public class Simplifie {
  /**
   * DOCUMENT ME!
   */
  public static ClassPathXmlApplicationContext appContext;

  /**
   * DOCUMENT ME!
   */
  public static BeanFactory factory;

  /**
   * DOCUMENT ME!
   */
  public static void init() {
    appContext = new ClassPathXmlApplicationContext("applicationContext.xml");
    factory = (BeanFactory) appContext;

    BasicDataSource dataSource = (BasicDataSource) factory.getBean("dataSource");

    JdbcTemplate jdbcTemplate = new JdbcTemplate(dataSource);
    jdbcTemplate.execute("drop TABLE IF EXISTS utilisateur");
    jdbcTemplate.execute(
      "create table utilisateur (id serial, nom varchar, prenom varchar)");

    for (int i = 1; i < 3; i++) {
      jdbcTemplate.execute("insert into utilisateur (nom, prenom) values ('A" +
        i + "', 'a" + i + "')");
    }
  }

  /**
   * Point d'entrée
   *
   * @param args Les arguments de la ligne de commande
   *
   * @throws SQLException L'exception sql levée
   */
  public static void main(String[] args) throws SQLException {
    init();

    JdbcUtilisateurDao dao = (JdbcUtilisateurDao) factory.getBean(
        "jdbcUtilisateurDao");

    List<Utilisateur> us = dao.getAll();
    log.info(us.toString());

    Utilisateur u = new Utilisateur(1, "aaaa", "AAAA");
    dao.ajouter(u);
    log.info("Utilisateur ajouté=" + u.toString() + " id pas modifié !");

    us = dao.getAll();
    log.info(us.toString());

    dao.ajouter2(u);
    log.info("Utilisateur ajouté=" + u.toString() + " id modifié !");

    dao.ajouter3(u);
    log.info("Utilisateur ajouté=" + u.toString() + " id modifié !");

    dao.ajouter4(u);
    log.info("Utilisateur ajouté=" + u.toString() + " id modifié !");


  }
}
