package fr.eni.ep3jasp.web;

import fr.eni.ep3jasp.business.UtilisateurService;

import fr.eni.ep3jasp.domain.Utilisateur;

import org.springframework.beans.factory.annotation.Autowired;

import org.springframework.http.HttpStatus;

import org.springframework.stereotype.Controller;

import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.servlet.support.ServletUriComponentsBuilder;

import java.util.Collection;

import javax.servlet.http.HttpServletResponse;


/**
 * DOCUMENT ME!
 *
 * @author $author$
 * @version $Revision$
  */
@Controller
@RequestMapping("/utilisateurs")
public class UtilisateurMvcController {
  /**
   * DOCUMENT ME!
   */
  @Autowired
  UtilisateurService utilisateurService;

  /**
   * DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   */
  @ResponseBody
  @RequestMapping(method = RequestMethod.GET)
  public Collection<Utilisateur> select() {
    return utilisateurService.select();
  }

  /**
   * DOCUMENT ME!
   *
   * @param id DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   */
  @ResponseBody
  @RequestMapping(value = "/{id}", method = RequestMethod.GET)
  public Utilisateur get(@PathVariable
  Long id) {
    return utilisateurService.get(id);
  }

  /**
   * DOCUMENT ME!
   *
   * @param utilisateur DOCUMENT ME!
   * @param response DOCUMENT ME!
   */
  @RequestMapping(method = RequestMethod.POST)
  @ResponseStatus(HttpStatus.CREATED)
  public void add(@RequestBody
  Utilisateur utilisateur, HttpServletResponse response) {
    utilisateurService.add(utilisateur);

    String location = ServletUriComponentsBuilder.fromCurrentRequest()
                                                 .pathSegment("{id}")
                                                 .buildAndExpand(utilisateur.getId())
                                                 .toUriString();

    response.setHeader("Location", location);
  }

  /**
   * DOCUMENT ME!
   *
   * @param id DOCUMENT ME!
   * @param utilisateur DOCUMENT ME!
   */
  @RequestMapping(value = "/{id}", method = RequestMethod.PUT)
  @ResponseStatus(HttpStatus.NO_CONTENT)
  public void update(@PathVariable
  Long id, @RequestBody
  Utilisateur utilisateur) {
    utilisateur.setId(id);
    utilisateurService.update(utilisateur);
  }
}
