package fr.eni.spring5.jsf.services;

import fr.eni.spring5.jsf.web.model.Tache;

import org.springframework.stereotype.Component;

import org.springframework.transaction.annotation.Transactional;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;


/**
 * Le DAO pour Tache
 *
 * @author $author$
 * @version $Revision$
  */
@Component
public class TacheDao {
  /**
   * L'entity manager
   */
  @PersistenceContext
  private EntityManager entityManager;

  /**
   * sauvegarde
   *
   * @param tache la tache
   */
  @Transactional
  public void save(Tache tache) {
    entityManager.persist(tache);
  }

  /**
   * Lister les taches
   *
   * @return La liste des taches
   */
  @SuppressWarnings("unchecked")
  public List<Tache> list() {
    return entityManager.createQuery("select t from Tache t").getResultList();
  }
}
