package fr.eni.ep3jasp.chap12.hateoas.ex1;

import fr.eni.ep3jasp.chap12.hateoas.ex1.domain.Departement;
import fr.eni.ep3jasp.chap12.hateoas.ex1.domain.Region;
import fr.eni.ep3jasp.chap12.hateoas.ex1.repository.DepartementRepository;
import fr.eni.ep3jasp.chap12.hateoas.ex1.repository.RegionRepository;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

// tag::code[]
@Component
public class Ex1CommandLineRunner implements org.springframework.boot.CommandLineRunner {
  private static final Logger LOGGER = LoggerFactory.getLogger(Ex1CommandLineRunner.class);

  @Autowired
  private RegionRepository regionRepository;
  @Autowired
  private DepartementRepository departementRepository;

	@Override
  public void run(String... strings) throws Exception {
    Region r53=new Region().code("53").nom("Bretagne");
    Departement d22=new Departement().code("22").nom("Côtes-d'armor").region(r53);
    Departement d29=new Departement().code("29").nom("Finistère").region(r53);
    Departement d35=new Departement().code("35").nom("Ille-et-Vilaine").region(r53);
    Departement d56=new Departement().code("56").nom("Morbihan").region(r53);

    Region r52=new Region().code("52").nom("Pays de la Loire");
    Departement d44=new Departement().code("44").nom("Loire-Atlantique").region(r52);
    Departement d49=new Departement().code("49").nom("Maine-et-Loire").region(r52);
    Departement d53=new Departement().code("53").nom("Mayenne").region(r52);
    Departement d72=new Departement().code("72").nom("Sarthe").region(r52);
    Departement d85=new Departement().code("85").nom("Vendée").region(r52);

    regionRepository.save(r53);
    regionRepository.save(r52);
    departementRepository.save(d22);
    departementRepository.save(d29);
    departementRepository.save(d35);
    departementRepository.save(d56);
    departementRepository.save(d44);
    departementRepository.save(d49);
    departementRepository.save(d53);
    departementRepository.save(d72);
    departementRepository.save(d85);

    regionRepository.findAll().forEach(System.out::println);
    departementRepository.findAll().forEach(System.out::println);
  }

}
// end::code[]