package fr.eni.ep3jasp.chap12.hateoas.ex1.domain;


import javax.persistence.*;
import java.io.Serializable;
import java.util.Objects;

// tag::code[]
@Entity
@Table(name = "departement")
public class Departement implements Serializable {

  private static final long serialVersionUID = 1L;

  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private Long id;

  @Column(name = "code")
  private String code;

  @Column(name = "nom")
  private String nom;

  @ManyToOne
  private Region region;

  // jhipster-needle-entity-add-field - JHipster will add fields here, do not remove
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public String getCode() {
    return code;
  }

  public Departement code(String code) {
    this.code = code;
    return this;
  }

  public void setCode(String code) {
    this.code = code;
  }

  public String getNom() {
    return nom;
  }

  public Departement nom(String nom) {
    this.nom = nom;
    return this;
  }

  public void setNom(String nom) {
    this.nom = nom;
  }

  public Region getRegion() {
    return region;
  }

  public Departement region(Region region) {
    this.region = region;
    return this;
  }

  public void setRegion(Region region) {
    this.region = region;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Departement departement = (Departement) o;
    if (departement.getId() == null || getId() == null) {
      return false;
    }
    return Objects.equals(getId(), departement.getId());
  }

  @Override
  public int hashCode() {
    return Objects.hashCode(getId());
  }

  @Override
  public String toString() {
    return "Departement{" +
          "id=" + getId() +
          ", code='" + getCode() + "'" +
          ", nom='" + getNom() + "'" +
          "}";
  }
}
// end::code[]