package fr.eni.ep3jasp;

import fr.eni.ep3jasp.cache.ex3.SimpleDepartementRepository;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cache.annotation.EnableCaching;

@SpringBootApplication
@EnableCaching
public class Ex3CacheRedis implements CommandLineRunner {

  private static final Logger LOGGER = LoggerFactory.getLogger(Ex3CacheRedis.class);

  public static void main(String[] args) {
    SpringApplication.run(Ex3CacheRedis.class, args);
  }

  @Autowired
  private SimpleDepartementRepository departementRepository;

  @Override
  public void run(String... args) throws Exception {
    departementRepository.cacheEvict();

    LOGGER.info("27->{}", departementRepository.getByCode("27"));
    LOGGER.info("44->{}", departementRepository.getByCode("44"));
    LOGGER.info("51->{}", departementRepository.getByCode("51"));

    LOGGER.info("27->{}", departementRepository.getByCode("27"));
    LOGGER.info("44->{}", departementRepository.getByCode("44"));
    LOGGER.info("51->{}", departementRepository.getByCode("51"));

    departementRepository.patch("27","__EURE__");
    LOGGER.info("27->{}", departementRepository.getByCode("27"));

  }
}
