package fr.eni.ep3jasp.cache.ex3;

import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.CachePut;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.stereotype.Component;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

// tag::code[]
@Component
public class SimpleDepartementRepository {
  @CacheEvict(value = "depCode", allEntries = true)
  public void cacheEvict() {
  }
  @CachePut(value = "depCode", key = "#depCode")
  public void patch(String depCode, String valeur) {
    simulationBase.put(depCode,valeur);
  }
  @Cacheable("depCode")
  public Departement getByCode(String regionCode) {
    try {
      Thread.sleep(2000L);
    } catch (InterruptedException e) {
      throw new IllegalStateException(e);
    }
    return new Departement(regionCode,  simulationBase.get(regionCode));
  }

  private Map<String,String> simulationBase = new ConcurrentHashMap<String,String>();
  public SimpleDepartementRepository() {
    simulationBase.put("01","AIN");
    simulationBase.put("02","AISNE");
    simulationBase.put("27","EURE");
    simulationBase.put("44","LOIRE-ATLANTIQUE");
    simulationBase.put("51","MARNE");
    //[...]
    simulationBase.put("03","ALLIER");
    simulationBase.put("974","LA REUNION");
    simulationBase.put("975","MAYOTTE");
  }
}
// end::code[]