package fr.eni.ep3jasp.mongodb.ex1;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

// tag::lanceur[]
@SpringBootApplication
public class Ex1MongoDB implements CommandLineRunner {

  private static final Logger LOGGER = LoggerFactory.getLogger(Ex1MongoDB.class);

  @Autowired
  private CapitaleRepository repository;

  public static void main(String[] args) {
    SpringApplication.run(Ex1MongoDB.class, args);
  }

  @Override
  public void run(String... args) throws Exception {
    repository.deleteAll();
    repository.save(new Capitale("Afghanistan", "Kaboul", "Asie"));
    repository.save(new Capitale("Afrique du Sud", "Pretoria", "Afrique"));
    repository.save(new Capitale("Albanie", "Tirana", "Europe"));
    repository.save(new Capitale("Algérie", "Alger", "Afrique"));
    repository.save(new Capitale("Allemagne", "Berlin", "Europe"));
    repository.save(new Capitale("Andorre", "Andorre-la-Vieille", "Europe"));
    repository.save(new Capitale("Angola", "Luanda", "Afrique"));
    repository.save(new Capitale("Antigua-et-Barbuda", "Saint John's", "Amérique"));
    repository.save(new Capitale("Arabie Saoudite", "Riyad", "Asie"));
    repository.save(new Capitale("Argentine", "Buenos Aires", "Amérique"));
    repository.save(new Capitale("Arménie", "Erevan", "Asie"));
    repository.save(new Capitale("Australie", "Canberra", "Océanie"));
    repository.save(new Capitale("Autriche", "Vienne", "Europe"));
    repository.save(new Capitale("Azerbaïdjan", "Bakou", "Asie"));

    // Recherche de toutes les capitales
    LOGGER.info("Toutes les capitalesavec l'usage de findAll():");
    for (Capitale capitale : repository.findAll()) {
      LOGGER.info("Capitale:{}", capitale);
    }

    // Recherche capitale par pays
    LOGGER.info("Capitale trouvé avec findByPays('Allemagne'):");
    LOGGER.info("Allemagne:{}", repository.findByPays("Allemagne"));

    LOGGER.info("Capitale trouvé avec findByCapitale('Canberra'):");
    LOGGER.info("Canberra:{}", repository.findByCapitale("Canberra"));

    LOGGER.info("Toutes les capitale de l'Asie avec findByContinent('Asie'):");
    for (Capitale capitale : repository.findByContinent("Asie")) {
      LOGGER.info("Capitale:{}", capitale);

      capitale.getId();
    }
  }
}
// end::lanceur[]