package fr.eni.ep3jasp.mongodb.ex1;

import static org.assertj.core.api.Assertions.*;

import java.util.List;

import org.assertj.core.api.Assertions;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.data.domain.Example;
import org.springframework.test.context.junit4.SpringRunner;

@RunWith(SpringRunner.class)
@SpringBootTest
public class CapitaleRepositoryTests {
    @Autowired
    CapitaleRepository repository;

    private Capitale chili, chine, chypre;

    @Before
    public void setUp() {
        repository.deleteAll();
        chili = repository.save(new Capitale("Chili", "Santiago","Amérique"));
        chine = repository.save(new Capitale("Chine","Pékin","Asie"));
        chypre = repository.save(new Capitale("Chypre","Nicosie"," Europe"));
    }

    @Test
    public void setsIdOnSave() {
        Capitale bresil = repository.save(new Capitale("Brésil", "Brasilia", "Amérique"));
        assertThat(bresil.getId()).isNotNull();
    }

    @Test
    public void findByContinent() {
        List<Capitale> result = repository.findByContinent("Amérique");
        Assertions.assertThat(result).hasSize(1).extracting("pays").contains("Chili");
    }

    @Test
    public void findsByExample() {
        Capitale exemple = new Capitale(null, null, "Amérique");
        List<Capitale> result = repository.findAll(Example.of(exemple));
        Assertions.assertThat(result).hasSize(1).extracting("pays").contains("Chili");
    }
}