package fr.eni.ep3jasp.mongodb.ex2;

import org.springframework.data.mongodb.repository.MongoRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.data.rest.core.annotation.RepositoryRestResource;

import java.util.List;

// tag::repository[]
@RepositoryRestResource(collectionResourceRel = "capitale", path = "capitales")
public interface CapitaleRepository extends MongoRepository<Capitale, String> {
    Capitale findByPays(@Param("pays") String pays);
    Capitale findByCapitale(@Param("capitale") String capitale);
    List<Capitale> findByContinent(@Param("continent") String continent);
}
// end::repository[]
