package fr.eni.ep3jasp.chap05;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.batch.item.ItemProcessor;

public class DepartementItemProcessor implements ItemProcessor<Departement, Departement> {

  private static final Logger log = LoggerFactory.getLogger(DepartementItemProcessor.class);

  @Override
  public Departement process(final Departement departement) throws Exception {
    final String code= departement.getCode().toUpperCase();
    final String nom = departement.getNom().toUpperCase();
    final Departement transformedDepartement = new Departement(code, nom);
    log.info("Converting (" + departement + ") into (" + transformedDepartement + ")");

    return transformedDepartement;
  }
}
