package fr.eni.ep3jasp.chap05.kotlin.spring5.mvc.app.controllers

import fr.eni.ep3jasp.chap05.kotlin.spring5.mvc.app.domain.Compte
import fr.eni.ep3jasp.chap05.kotlin.spring5.mvc.app.repositories.CompteRepository
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.http.MediaType
import org.springframework.web.bind.annotation.*
import java.util.*

// tag::sbmvckt11[]
@RestController
@RequestMapping(value = "\${api.base}", produces = arrayOf(MediaType.APPLICATION_JSON_UTF8_VALUE))
class CompteController {
    @Autowired
    lateinit private var compteRepository: CompteRepository;
    @RequestMapping("/comptes", method = arrayOf(RequestMethod.GET))
    fun getBlogPosts() = compteRepository.findAll()

    @RequestMapping("/compte/{id}", method = arrayOf(RequestMethod.GET))
    fun getBlogPost(@PathVariable id: UUID) = compteRepository.findById(id);

    @RequestMapping("/compte/{id}", method = arrayOf(RequestMethod.PATCH))
    fun updateBlogPost(@PathVariable id: UUID, @RequestBody nom: String) {
        var compte : Optional<Compte> = compteRepository.findById(id);
        compte.get().nom = nom
        compteRepository.save(compte.get());
    }

    @RequestMapping("/compte/{id}", method = arrayOf(RequestMethod.DELETE))
    fun deleteBlogPost(@PathVariable id: UUID) = compteRepository.deleteById(id);

    @RequestMapping(value = "/compte", method = arrayOf(RequestMethod.POST))
    fun postBlogPost(@RequestBody nom: String) = compteRepository.save(Compte(nom = nom))
}
// end::sbmvckt11[]